<?php
/**
 * 
 * THIS FILE MUST BE LOCATED IN THE PLUGIN FOLDER *
 * 
**/
defined( 'SOSIDEE_DYNAMIC_QRCODE' ) or die( 'you were not supposed to be here' );

if( !class_exists('SOSIDEE_CLASS_LOADER') ) {
    /**
     * Class autoloader
     * It works for all sosidee's plugins installed
     * Class namespaces are transformed into a folder structure
     */
    class SOSIDEE_CLASS_LOADER
    {
        
        public function load( $class )
        {
            $items = explode('\\', $class);
            if ( key_exists($items[0], $this->roots) ) { //check if the class namespace root has been added (non-sosidee's plugins exit here)
                $items[0] = $this->roots[ $items[0] ];
                $class_path = implode(DIRECTORY_SEPARATOR, $items);
                $file_path = plugin_dir_path( __DIR__ ) . strtolower($class_path) . '.php';
                $file_path = realpath( $file_path );
                if ( file_exists($file_path) ) {
            	    require_once $file_path;
            	}
            }
        }

        public function add( $namespace, $folder ) {
            $this->roots[$namespace] = $folder;
        }

        //just the usual way to get a singleton
        private static $instance = null;
        final public static function instance() {
            if (self::$instance == null) {
                self::$instance = new \SOSIDEE_CLASS_LOADER();

                spl_autoload_register( array(self::$instance, 'load') );

            }

            self::requireFile('sos/wp/functions');

            return self::$instance;
        }

        private $roots;
        private function __construct() {
            $this->roots = array();
        }

        private static function requireFile( $filename ) {
            $file = implode( DIRECTORY_SEPARATOR, explode( '/', strtolower($filename) ) );
            $file_path = __DIR__ . DIRECTORY_SEPARATOR . $file . '.php';
            $file_path = realpath( $file_path );
            if ( file_exists( $file_path ) ) {
                require_once $file_path;
            }
        }

    }
}
